<?xml version="1.0" encoding="UTF-8" ?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:output method="xml" standalone="yes" indent="yes"/>

<xsl:template match="/">
	<HTML xmlns="http://www.w3.org/1999/xhtml">
		<META http-equiv="Content-Style-Type" content="text/css" />
		<HEAD>
			<xsl:comment>load the mktree</xsl:comment>
			<SCRIPT SRC="mktree.js" LANGUAGE="JavaScript"></SCRIPT> 
			<LINK REL="stylesheet" HREF="mktree.css"/>			
		</HEAD>
		<BODY>
			<xsl:apply-templates/>
		</BODY>
	</HTML>
</xsl:template>

<xsl:template name="fieldTree">
	<!-- xsl:param name="parent"/-->
	<xsl:if test="count(field)!=0">
		<LI>
			Fields
			<UL>
				<xsl:for-each select="field">
					<LI>
						<!--xsl:attribute name="id">
							<xsl:value-of select="$parent"/>_<xsl:value-of select="name"/>
						</xsl:attribute-->
						<xsl:value-of select="name"/>
						<xsl:if test="count(desc)!=0">
							<UL>
								<LI>
									<xsl:value-of select="desc"/>
								</LI>
							</UL>	
						</xsl:if>
					</LI>			
				</xsl:for-each>		
			</UL>
		</LI>
	</xsl:if>
</xsl:template>

<xsl:template name="methodTree">
	<!-- xsl:param name="parent"/ -->
	<xsl:if test="count(method)!=0">
		<LI>
			Methods
			<UL>
				<xsl:for-each select="method">
					<LI>
						<!-- xsl:attribute name="id">
							<xsl:value-of select="$parent"/>_<xsl:value-of select="name"/>
						</xsl:attribute -->
						<xsl:value-of select="name"/>(<xsl:value-of select="args"/>)
						<xsl:if test="count(desc)!=0">
						<UL>
							<LI>
								<xsl:value-of select="desc"/>
							</LI>
						</UL>	
						</xsl:if>					
					</LI>			
				</xsl:for-each>		
			</UL>
		</LI>
	</xsl:if>
</xsl:template>

<xsl:template name="classTree">
	Classes
	<UL>
		<xsl:for-each select="class">
			<LI>
				<xsl:attribute name="id">
					<xsl:value-of select="name"/>
				</xsl:attribute>
				<xsl:value-of select="name"/>
				&#160;
				<xsl:if test="count(base)!=0">
					<A>
						<xsl:attribute name="href">
							#<xsl:value-of select="base"/>
						</xsl:attribute>
						<xsl:value-of select="base"/>				
					</A>
				</xsl:if>
				
				<xsl:if test="count(method|field)!=0">
					<UL>
						<xsl:call-template name="methodTree">
							<!-- xsl:with-param name="parent">
								<xsl:value-of select="name"/>
							</xsl:with-param -->
						</xsl:call-template>
						<xsl:call-template name="fieldTree">
							<!-- xsl:with-param name="parent">
								<xsl:value-of select="name"/>
							</xsl:with-param -->
						</xsl:call-template>
					</UL>
				</xsl:if>				
			</LI>		
		</xsl:for-each>
	</UL>
</xsl:template>

<xsl:template name="functionTree">
Functions
<UL id="functionTree">
	<xsl:for-each select="function">
		<LI>
			<xsl:attribute name="id">
				<xsl:value-of select="name"/>
			</xsl:attribute>
			<xsl:value-of select="name"/>(<xsl:value-of select="args"/>)
			<xsl:if test="count(desc)!=0">
				<UL>
					<LI>
						<xsl:value-of select="desc"/>
					</LI>
				</UL>	
			</xsl:if>
		</LI>
	</xsl:for-each>
</UL>
</xsl:template>

<xsl:template match="exports">
Hierarchy:
<UL class="mktree">
	<LI>
		<xsl:call-template name="classTree"/>
	</LI>
	<LI>
		<xsl:call-template name="functionTree"/>
	</LI>
</UL>
</xsl:template>

</xsl:stylesheet>