<?xml version="1.0" encoding="UTF-8" ?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:output method="xml" standalone="yes" indent="yes"/>

<xsl:template match="/">
	<HTML xmlns="http://www.w3.org/1999/xhtml">
		<META http-equiv="Content-Style-Type" content="text/css" />
		<HEAD>
			<xsl:comment>load the mktree</xsl:comment>			
		</HEAD>
		<BODY>
			<xsl:apply-templates/>
		</BODY>
	</HTML>
</xsl:template>

<xsl:template match="name|base|args|desc" mode="table-entry">
	<TD><xsl:apply-templates /></TD>
</xsl:template>

<xsl:template name="class-info">
	<TR>
		<xsl:apply-templates select="name|base" mode="table-entry"/>						
	</TR>
	<TR>
		<TD colspan="2">
			<xsl:if test="count(method)!=0">
				<TABLE BORDER="0">
					<CAPTION>Methods</CAPTION>
					<THEAD>
						<TR>
							<TH>Name</TH>
							<TH abbr="Args." >Arguments</TH>
							<xsl:if test="count(method[desc])!=0">
								<TH abbr="Desc." >Description</TH>
							</xsl:if>
						</TR>
					</THEAD>
					<xsl:for-each select="method">
						<TR>
							<xsl:apply-templates mode="table-entry"/>									
						</TR>
					</xsl:for-each>
				</TABLE>
			</xsl:if>
			<xsl:if test="count(field)!=0">
				<TABLE BORDER="0">
					<CAPTION>Fields</CAPTION>
					<THEAD>
						<TR>
							<TH>Name</TH>
							<TH>Desc</TH>
						</TR>
					</THEAD>
					<xsl:for-each select="field">
						<TR>
							<xsl:apply-templates mode="table-entry"/>
						</TR>
					</xsl:for-each>
				</TABLE>
			</xsl:if>
		</TD>
	</TR>
</xsl:template>

<xsl:template match="exports">
	<xsl:if test="count(class)!=0" >
		<TABLE BORDER="0">
			<CAPTION>Classes</CAPTION>
			<THEAD>
				<TR>
					<TH>Name</TH>
					<xsl:if test="count(class[base])!=0">
						<TH>Base</TH>
					</xsl:if>
				</TR>
			</THEAD>
			<xsl:for-each select="class">
				<xsl:call-template name="class-info" />
			</xsl:for-each>
		</TABLE>
	</xsl:if>
	<xsl:if test="count(function)!=0">
		<TABLE BORDER="0">
			<CAPTION>Functions</CAPTION>
			<THEAD>
				<TR>
					<TH>Name</TH>
					<TH abbr="Args.">Arguments</TH>
					<TH abbr="Desc.">Description</TH>
				</TR>
			</THEAD>
			<xsl:for-each select="function">
				<TR>
					<xsl:apply-templates mode="table-entry"/>
				</TR>
			</xsl:for-each>
		</TABLE>			
	</xsl:if>
</xsl:template> 

</xsl:stylesheet>